#include <RTClib.h> /* Nástroje → Spravovat knihovny (zkratka Ctrl+Shift+I) → Vyhledat „RTClib" (by „NeiroN”), verze knihovny 1.6.2. */

DS3231 rtc;

char buf[20];
char data[] = "dratek.cz";

void i2c_eeprom_write_byte( int deviceaddress, unsigned int eeaddress, byte data );
byte i2c_eeprom_read_byte( int deviceaddress, unsigned int eeaddress );
void i2c_eeprom_write_page( int deviceaddress, unsigned int eeaddresspage, byte* data, byte length );
void i2c_eeprom_read_buffer( int deviceaddress, unsigned int eeaddress, byte *buffer, int length );

void setup() {
  Serial.begin(9600);
  Wire.begin();
  rtc.begin();

  // nastaveni data a casu, pouzit pouze pri prvnim nahrani programu pote zakomentovat
  //rtc.adjust(DateTime(__DATE__, __TIME__)); // pouzit pouze pri prvnim nahravani

  // zapis do EEPROM, pouzit pouze pri prvnim nahrani programu pote zakomentovat
  //  Serial.println("Zahajuji zapis dat do pameti.");
  //  i2c_eeprom_write_page(0x57, 0, (byte *)data, sizeof(data));
  //  delay(100);
  //  Serial.println("Zapis dokoncen.");
}

void loop() {
  static bool first = false;
  // Jednorazove cteni z pameti
  if ( first == false ) {
    first = true;

    Serial.print("Data v pameti: ");
    int addr = 0; //first address
    byte b = i2c_eeprom_read_byte(0x57, 0);

    while (b != 0)
    {
      Serial.print((char)b);
      addr++;
      b = i2c_eeprom_read_byte(0x57, addr); //access an address from the memory
    }
    Serial.println();
  }
  
  DateTime now = rtc.now();
  Serial.println(now.tostr(buf));

  Serial.print("Unix cas 1970/1/1 = ");
  Serial.print(now.unixtime());
  Serial.print("s = ");
  Serial.print(now.unixtime() / 86400L);
  Serial.println("d");
  Serial.println();

  delay(1000);
}

void i2c_eeprom_write_byte( int deviceaddress, unsigned int eeaddress, byte data ) {
  int rdata = data;
  Wire.beginTransmission(deviceaddress);
  Wire.write((int)(eeaddress >> 8)); // MSB
  Wire.write((int)(eeaddress & 0xFF)); // LSB
  Wire.write(rdata);
  Wire.endTransmission();
}

byte i2c_eeprom_read_byte( int deviceaddress, unsigned int eeaddress ) {
  byte rdata = 0xFF;
  Wire.beginTransmission(deviceaddress);
  Wire.write((int)(eeaddress >> 8)); // MSB
  Wire.write((int)(eeaddress & 0xFF)); // LSB
  Wire.endTransmission();
  Wire.requestFrom(deviceaddress, 1);
  if (Wire.available()) rdata = Wire.read();
  return rdata;
}

// Upozorneni: parametr address znaci adresu stranky, ne konkretniho byte
// Data mohou mit velikost max. 30 bytu.
void i2c_eeprom_write_page( int deviceaddress, unsigned int eeaddresspage, byte* data, byte length ) {
  Wire.beginTransmission(deviceaddress);
  Wire.write((int)(eeaddresspage >> 8)); // MSB
  Wire.write((int)(eeaddresspage & 0xFF)); // LSB
  byte c;
  for ( c = 0; c < length; c++)
    Wire.write(data[c]);
  Wire.endTransmission();
}

void i2c_eeprom_read_buffer( int deviceaddress, unsigned int eeaddress, byte *buffer, int length ) {
  Wire.beginTransmission(deviceaddress);
  Wire.write((int)(eeaddress >> 8)); // MSB
  Wire.write((int)(eeaddress & 0xFF)); // LSB
  Wire.endTransmission();
  Wire.requestFrom(deviceaddress, length);
  int c = 0;
  for ( c = 0; c < length; c++ )
    if (Wire.available()) buffer[c] = Wire.read();
}
